%{?nodejs_find_provides_and_requires}

%global enable_tests 1

Name:       nodeunit
Version:    0.9.1
Release:    %mkrel 2
Summary:    Easy asynchronous unit testing framework for Node.js
License:    MIT
Group:      System/Libraries
URL:        https://github.com/caolan/nodeunit
Source0:    https://registry.npmjs.org/nodeunit/-/nodeunit-%{version}.tgz
Patch0:     %{name}-0.8.6-Load-system-modules.patch
Patch1:     %{name}-0.8.6-Use-system-assert.js.patch
Patch2:     %{name}-0.9.1-Use-newer-should.patch
Patch3:     %{name}-0.9.1-Use-fs-stat.patch

BuildArch:  noarch

BuildRequires:  nodejs-packaging

%if 0%{?enable_tests}
BuildRequires:  coffee-script
BuildRequires:  expresso
BuildRequires:  npm(async)
BuildRequires:  npm(console.log)
BuildRequires:  npm(ejs)
BuildRequires:  npm(paperboy)
BuildRequires:  npm(should)
BuildRequires:  npm(tap)
%endif

%description
Nodeunit provides an easy asynchronous unit testing framework for Node.js:
 - helps you avoid common pitfalls when testing asynchronous code
 - easy to add test cases with setUp and tearDown functions if you wish
 - flexible reporters for custom output
 - built-in support for HTML and jUnit XML
 - allows the use of mocks and stubs


%prep
%setup -q -n package
# Remove bundled dependencies
rm -rf deps/
rm -f lib/assert.js
# The requires need to be amended to use the unbundled dependencies.
%patch0 -p1
%patch1 -p1
# Fix some tests for changes in npm(should)
%patch2 -p1
# Fix use of path.exists in tests
%patch3 -p1

%nodejs_fixdep async '^1.5.0'
%nodejs_fixdep console.log '~0.1'
%nodejs_fixdep ejs '~1.0'
%nodejs_fixdep tap '^0.4.4'


%build
#nothing to do


%install
mkdir -p %{buildroot}%{nodejs_sitelib}/nodeunit
cp -pr package.json index.js lib/ \
    %{buildroot}%{nodejs_sitelib}/nodeunit
install -p -D -m0755 bin/nodeunit \
    %{buildroot}%{nodejs_sitelib}/nodeunit/bin/nodeunit
mkdir -p %{buildroot}%{_bindir}
ln -sf %{nodejs_sitelib}/nodeunit/bin/nodeunit \
    %{buildroot}%{_bindir}/nodeunit

install -p -D -m0644 man1/nodeunit.1 \
    %{buildroot}%{_mandir}/man1/nodeunit.1

# Put non-javascript arch independent files in _datadir to comply with Node.js
# packaging guidelines.
mkdir -p %{buildroot}%{_datadir}/nodeunit/bin
install -p -D -m0644 bin/nodeunit.json \
    %{buildroot}%{_datadir}/nodeunit/bin/nodeunit.json
cp -pr share/ %{buildroot}%{_datadir}/nodeunit
mkdir -p %{buildroot}%{nodejs_sitelib}/nodeunit/bin
ln -sf %{_datadir}/nodeunit/bin/nodeunit.json \
    %{buildroot}%{nodejs_sitelib}/nodeunit/bin/nodeunit.json
ln -sf %{_datadir}/nodeunit/share \
    %{buildroot}%{nodejs_sitelib}/nodeunit/share


%nodejs_symlink_deps


%if 0%{?enable_tests}
%check
%nodejs_symlink_deps --check
# Fails in Koji
rm -f test/test-httputil.js
%__nodejs ./bin/nodeunit test --reporter tap
%endif


%files
%doc CONTRIBUTORS.md README.md doc/ examples/
%license LICENSE
%{nodejs_sitelib}/nodeunit
%{_bindir}/nodeunit
%{_datadir}/nodeunit
%{_mandir}/man1/nodeunit.1*


%changelog
* Wed Sep 28 2016 neoclust <neoclust> 0.9.1-2.mga6
+ Revision: 1057441
- Rebuild against fixed nodejs stack

* Fri Apr 08 2016 tv <tv> 0.9.1-1.mga6
+ Revision: 999287
- new release

  + umeabot <umeabot>
    - Mageia 6 Mass Rebuild

* Sun Nov 15 2015 tv <tv> 0.8.6-1.mga6
+ Revision: 903209
- imported package nodeunit

